# Register the HNetCfg library (once)
# regsvr32 hnetcfg.dll

# Create a NetSharingManager object
$m = New-Object -ComObject HNetCfg.HNetShare

# List every connections (for each)
# $m.EnumEveryConnection |% { $m.NetConnectionProps.Invoke($_) }

# Disable sharing
# Find connection (where)
$c = $m.EnumEveryConnection |? { $m.NetConnectionProps.Invoke($_).Name -eq "vEthernet (LAN)" }
$config = $m.INetSharingConfigurationForINetConnection.Invoke($c)
$config.DisableSharing()
$c = $m.EnumEveryConnection |? { $m.NetConnectionProps.Invoke($_).Name -eq "WLAN" }
$config = $m.INetSharingConfigurationForINetConnection.Invoke($c)
$config.DisableSharing()


# Enable sharing
# Find connection
$c = $m.EnumEveryConnection |? { $m.NetConnectionProps.Invoke($_).Name -eq "WLAN" }

# Get sharing configuration
$config = $m.INetSharingConfigurationForINetConnection.Invoke($c)

# See if sharing is enabled
# Write-Output $config.SharingEnabled

# See the role of connection in sharing
# 0 - public, 1 - private
# Only meaningful if SharingEnabled is True
# Write-Output $config.SharingType

# Enable sharing (0 - public, 1 - private)
$config.EnableSharing(0)

# Set private connection
$c = $m.EnumEveryConnection |? { $m.NetConnectionProps.Invoke($_).Name -eq "vEthernet (LAN)" }
$config = $m.INetSharingConfigurationForINetConnection.Invoke($c)
$config.EnableSharing(1)
